#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include <wx/app.h>
#include <wx/button.h>
#include <wx/checktree.h>
#include <wx/frame.h>
#include "wx/xrc/xmlres.h"

class MyFrame : public wxFrame
{
    public:
        MyFrame()
        {
            wxXmlResource::Get()->LoadFrame(this, (wxWindow* )NULL, wxT("MyFrame"));
            m_treeCtrl = XRCCTRL((wxWindow& )*this, "m_treeCtrl", wxCheckTree);
            if (m_treeCtrl)
            {
                m_treeCtrl->Init();

                wxTreeItemId root=m_treeCtrl->AddRoot("Root");
                first_id=m_treeCtrl->AppendItem(root,"first");
                wxTreeItemId second_id=m_treeCtrl->AppendItem(root,"second");
                m_treeCtrl->Expand(root);

                m_treeCtrl->MakeCheckable(first_id);
                m_treeCtrl->MakeCheckable(second_id);

                 XRCCTRL((wxWindow& )*this, "clickme_btn", wxButton)->Bind(wxEVT_COMMAND_BUTTON_CLICKED,
                    wxCommandEventHandler(MyFrame::CheckFirst), this, XRCID("clickme_btn"));
            }
        }

    private:
        wxTreeItemId first_id;
        wxCheckTree* m_treeCtrl;
        void CheckFirst( wxCommandEvent& event )
        {
            m_treeCtrl->Check(first_id);
        }
};

//application
class myApp : public wxApp
{
    public:
        bool OnInit()
        {
            wxXmlResource::Get()->InitAllHandlers();
            wxXmlResource::Get()->Load("resource.xrc");

            MyFrame *frame = new MyFrame();
            frame->Show(true);

            return true;
        }
};

IMPLEMENT_APP(myApp);
